<?php
    chdir('..');
    require_once ('../src/validate.php');
    require_once ('../functions/imap.php');
    require_once ('../functions/strings.php');
    require_once ('../config/config.php');

    header('Pragma: ');
    header('Cache-Control: cache');

    global $username, $key, $imapServerAddress, $imapPort;

    $imap_stream = sqimap_login($username, $key, $imapServerAddress, $imapPort, 0);
    $read = sqimap_mailbox_select($imap_stream, $mailbox);

    $read = sqimap_run_command ($imap_stream, "FETCH $passed_id BODY.PEEK[HEADER.FIELDS (Subject)]", true, $response, $readmessage);
    $subject = substr($read[1], strpos($read[1], ' '));
    $subject = trim($subject);

    if (isset($subject) && $subject != '') {
	$subject = htmlentities($subject);
    } else {
	$subject = _("<No subject>");
	$subject = htmlentities($subject);
    }
    $filename = "$subject" . '.eml';


    global $HTTP_USER_AGENT;

    $isIE = 0;

    if (strstr($HTTP_USER_AGENT, 'compatible; MSIE ') !== false &&
        strstr($HTTP_USER_AGENT, 'Opera') === false) {
        $isIE = 1;
    }

    if (strstr($HTTP_USER_AGENT, 'compatible; MSIE 6') !== false &&
        strstr($HTTP_USER_AGENT, 'Opera') === false) {
        $isIE6 = 1;
    }

    $filename = ereg_replace('[^-a-zA-Z0-9\.]', '_', $filename);

    if ($isIE && !isset($isIE6)) {
            header("Content-Disposition: inline; filename=$filename");
            header("Content-Type: application/download; name=\"$filename\"");
    } else {
            header("Content-Disposition: attachment; filename=\"$filename\"");
            header("Content-Type: application/octet-stream; name=\"$filename\"");
    }

    $sid = sqimap_session_id();
    // Don't kill the connection if the browser is over a dialup
    // and it would take over 30 seconds to download it.

    // dont call set_time_limit in safe mode.
    if (!ini_get("safe_mode")) {
        set_time_limit(0);
    }
    fputs ($imap_stream, "$sid FETCH $passed_id RFC822\r\n");

    $cnt = 0;
    $continue = true;
    $read = fgets ($imap_stream,4096);
    // This could be bad -- if the section has sqimap_session_id() . ' OK'
    // or similar, it will kill the download.
    while (!ereg("^".$sid." (OK|BAD|NO)(.*)$", $read, $regs)) {
      if (trim($read) == ')==') {
          $read1 = $read;
          $read = fgets ($imap_stream,4096);
          if (ereg("^".$sid." (OK|BAD|NO)(.*)$", $read, $regs)) {
              return;
          } else {
              echo $read1 . $read;
          }
      } else if ($cnt) {
          echo $read;
      }
      $read = fgets ($imap_stream,4096);
      $cnt++;
    }

?>
